char ident[] = "@(#)xelm V1.0 93/11/10 SNI BA NM 124";

/*
 * System includes 
 */
#include	<stdio.h>
#include	<signal.h>
#include	<malloc.h>
#include	<errno.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include        <unistd.h>
#include	<Xm/Xm.h>
#include	<X11/Shell.h>
#include	<Xm/PushB.h>
#include	"xelm.h"

/*
 * include the default bitmaps
 */

#include	"flagup"
#include	"flagdown"
#include	"elm_in_use"

/*
 * Global Variables
 */
XtAppContext	kontext;
Widget		applShell;
Widget		buttonW;
Display		*display;
ApplResTyp	applResources;
XtIntervalId	timer;
int		currentstate = XIB_EMPTY;
char		mail_p[80];

/*
 * here we stow all the pixmaps
 * and the texts
 */
Pixmap  	buttonpixmap[XIB_MAXMODE+1];
XmString	buttontext[XIB_MAXMODE+1];

/*
 * external references
 */

extern	char	*sys_errlist[];
static int fstat();


/*
 * command-line options
 */

static XrmOptionDescRec options[] = {
	{ "-readmailcommand", ".readmailcommand", XrmoptionSepArg, NULL },
	{ "-interval",        ".interval",	  XrmoptionSepArg, NULL },
	{ "-tracelevel",      ".tracelevel",      XrmoptionSepArg, NULL },
	{ "-emptytext",       ".emptytext",       XrmoptionSepArg, NULL },
	{ "-fulltext",        ".fulltext",        XrmoptionSepArg, NULL },
	{ "-inusetext",       ".inusetext",       XrmoptionSepArg, NULL },
	{ "-emptypixmap",     ".emptypixmap",     XrmoptionSepArg, NULL },
	{ "-fullpixmap",      ".fullpixmap",      XrmoptionSepArg, NULL },
	{ "-inusepixmap",     ".inusepixmap",     XrmoptionSepArg, NULL },
	{ "-showtext",        ".showtext",        XrmoptionSepArg, NULL },
	{ "-nodaemon",        ".nodaemon",        XrmoptionSepArg, NULL },
	};

/*
 * Application Resources
 */
static XtResource resources[] = {
	{ XibNcommand, XibCCommand,
	  XmRString, sizeof(String),
	  XtOffset(ApplResTyp*, command),
	  XmRString, ""
	},
	{ XibNappDefaultsVersion, XibCAppDefaultsVersion,
	  XmRInt, sizeof(int),
	  XtOffset(ApplResTyp*, version),
	  XmRString, "0"
	},
	{ XibNinterval, XibCInterval,
	  XmRInt, sizeof(int),
	  XtOffset(ApplResTyp*, interval),
	  XmRString, XIB_DEF_INTERVAL
	},
	{ XibNtracelevel, XibCTracelevel,
	  XmRInt, sizeof(int),
	  XtOffset(ApplResTyp*,tracelevel),
	  XmRString, XIB_DEF_TRACELEVEL
	},
	{ XibNinusetext, XibCInusetext,
	  XmRString, sizeof(String),
	  XtOffset(ApplResTyp*,inusetext),
	  XmRString, "Can't open Mailbox"
	},
	{ XibNemptytext, XibCEmptytext,
	  XmRString, sizeof(String),
	  XtOffset(ApplResTyp*,emptytext),
	  XmRString, "No Mail"
	},
	{ XibNfulltext, XibCFulltext,
	  XmRString, sizeof(String),
	  XtOffset(ApplResTyp*,fulltext),
	  XmRString, "You have Mail"
	},
	{ XibNemptypixmap, XibCEmptypixmap,
	  XmRString, sizeof(String),
	  XtOffset(ApplResTyp*,emptypixmapfile),
	  XmRString, ""
	},
	{ XibNfullpixmap, XibCFullpixmap,
	  XmRString, sizeof(String),
	  XtOffset(ApplResTyp*,fullpixmapfile),
	  XmRString, ""
	},
	{ XibNinusepixmap, XibCInusepixmap,
	  XmRString, sizeof(String),
	  XtOffset(ApplResTyp*,inusepixmapfile),
	  XmRString, ""
	},
	{ XibNshowtext, XibCShowtext,
	  XmRBool, sizeof(Bool),
	  XtOffset(ApplResTyp*,showtext),
	  XmRBool, False
	},
	{ XibNnodaemon, XibCNodaemon,
	  XmRBool, sizeof(Bool),
	  XtOffset(ApplResTyp*,nodaemon),
	  XmRBool, False
	},
	};
	


main(argc, argv)
int	argc;
char	*argv[];
{
	Cardinal	argcTmp;
	String		*argvTmp;
	int		i;
	Arg		args[10];
	Cardinal	n;


	XtToolkitInitialize();
	kontext = XtCreateApplicationContext();


	argcTmp = argc;
	argvTmp = (String *) XtMalloc ((Cardinal)(argc*sizeof(String)));
	for (i=0; i < argc; i++)
		{
		argvTmp[i] = XtNewString(argv[i]);
		}

	strcpy (mail_p, getenv("MAIL"));
	if (strlen (mail_p) == 0)
	{
		strcpy (mail_p, "/usr/spool/mail/");
		strcat (mail_p, getenv("USER"));
	}

	if (access (mail_p, R_OK | W_OK) != 0)
	{
		fprintf (stderr, "Can't open folder %s for reading!\n", mail_p);
		exit (2);
	}

	display = XtOpenDisplay(kontext, (String)NULL,(String)NULL,
			APPL_KLASSE, options, XtNumber(options),
			&argc, argv);


	if (display == NULL)
		{
		XtAppError(kontext,"Display could not be opened");
		}

	if (argc != 1)
		{
		paramerror(argc-1,argv+1);
		}

	/*
	 * Create Application Shell
	 *
	 * Keep it auto-rezizable
	 */
	n = 0;
	XtSetArg (args[n], XmNargc, argcTmp); n++;
	XtSetArg (args[n], XmNinput, False); n++;
	XtSetArg (args[n], XmNargv, argvTmp); n++;
	XtSetArg (args[n], XmNscreen, DefaultScreenOfDisplay(display)); n++;
	XtSetArg (args[n], XmNallowShellResize, True); n++;
	applShell = XtAppCreateShell((String)NULL, APPL_KLASSE,
			applicationShellWidgetClass, display, args, n);

	/*
	 * make the button
	 * it can either display PIXMAPS or STRINGS,
	 * which is configurable via the showtext resource
	 * 
	 */
	n = 0;
	XtSetArg (args[n], XmNtraversalOn, False); n++;
	buttonW = XtCreateManagedWidget ("button", xmPushButtonWidgetClass,
			applShell, args, n);

	/*
	 * then read the application resources
	 * and process them
	 */

	readApplicationResources(applShell);

	n = 0;
	if (applResources.showtext == True)
	{
		XtSetArg (args[n], XmNlabelType, XmSTRING); n++;
		XtSetArg (args[n], XmNlabelString, buttontext[XIB_EMPTY]); n++;
	}
	else
	{
		XtSetArg (args[n], XmNlabelType, XmPIXMAP); n++;
		XtSetArg (args[n], XmNlabelPixmap, buttonpixmap[XIB_EMPTY]); n++;
		XtSetArg (args[n], XmNlabelInsensitivePixmap, buttonpixmap[XIB_INUSE]); n++;
	}
	XtSetArg (args[n], XmNrecomputeSize, True); n++;
	XtSetValues(buttonW, args, n);

	/*
	 * If a command is specified, it can be started by pressing the
	 * button.
	 */
	if (strcmp(applResources.command,"") != 0)
		XtAddCallback(buttonW, XmNactivateCallback, 
		startreaderCB, (caddr_t)NULL);

	XtSetMappedWhenManaged(applShell, False);

	XtRealizeWidget(applShell);

	/*
	 * check the mailbox
	 * the routine will initialize a timer to call for the next check
	 */

	checkmailboxCB(applShell,(caddr_t)NULL, (caddr_t)NULL);

	XtMapWidget(applShell);

	XtAppMainLoop(kontext);

}

/*
 *	Function:	readApplicationResources
 *
 *	reads the Application resources and process them
 *
 */
void	readApplicationResources(applShell)
Widget	applShell;
{
	char	*buf;

	XtGetApplicationResources (applShell, &applResources,
				resources, XtNumber(resources),
				(Arg *)NULL, 0);

	/*
	 * If there is no set DISPLAY Shell variable in the environment,
	 * set ours, for the sake of our children
	 */

	if (strcmp(getenv("DISPLAY"),"") == 0)
		{
		if (applResources.tracelevel > 0)
			{
			fprintf(stderr,"setting DISPLAY=%s\n",
				DisplayString(display));
			}
		buf = (char *)malloc(strlen(DisplayString(display))+
					strlen("DISPLAY=")+2);
		sprintf(buf,"DISPLAY=%s",DisplayString(display));
		putenv(buf);
		}
		
	if (strcmp(mail_p,"") == 0)
	{
		fprintf(stderr,"No Mailbox specified..exiting\n");
		exit(1);
	}

	/*
	 * Convert the resource-text into Compund-Strings
	 */
	buttontext[XIB_EMPTY]	= XmStringCreate(applResources.emptytext,
					XmSTRING_DEFAULT_CHARSET);
	buttontext[XIB_FULL]	= XmStringCreate(applResources.fulltext,
					XmSTRING_DEFAULT_CHARSET);
	buttontext[XIB_INUSE]	= XmStringCreate(applResources.inusetext,
					XmSTRING_DEFAULT_CHARSET);

	/*
	 * and free the memory used by the application resources
	 */
	XtFree(applResources.emptytext);
	XtFree(applResources.fulltext);
	XtFree(applResources.inusetext);

	/*
	 * load bitmaps is we need them
	 */
	if (applResources.showtext == False)
		{
		loadBitmap(buttonW,&buttonpixmap[XIB_EMPTY],
			   applResources.emptypixmapfile,
			   flagdown_bits,flagdown_width,flagdown_height);
		loadBitmap(buttonW,&buttonpixmap[XIB_FULL],
			   applResources.fullpixmapfile,
			   flagup_bits,flagup_width,flagup_height);
		loadBitmap(buttonW,&buttonpixmap[XIB_INUSE],
			   applResources.inusepixmapfile,
			   inuse_bits,inuse_width,inuse_height);
		}
	/*
	 * shall we become a daemon ?
	 */

	if (applResources.nodaemon == True)
		return;

	if (applResources.tracelevel > 0)
		{
		fprintf(stderr,"becoming a daemon\n");
		}

	if (fork())
		exit(0);

#ifdef SVR4
	setsid();
#else
	setpgrp();
#endif

	signal(SIGHUP, SIG_IGN);

	if (fork())
		exit(0);


	}


/*
 *	Startreader Callback
 *
 *	Called when the button is pressed.
 *
 *	The process forks. The child will start the given command via
 *		/bin/sh -c
 *
 *	The parent will set the button to insensitive,
 *	try to get rid of the input focus,
 *	prepare a handler for when the child (command) dies
 *	and suspend polling the mailbox
 *
 *	
 */
void startreaderCB(w,client_data, call_data)
Widget	w;
caddr_t	client_data;
caddr_t	call_data;
{
	/*
	 * if not activated by Mouse-Button1
	 * do not execute
	 */

	if (applResources.tracelevel > 0)
		{
		fprintf(stderr,"xbutton = %d\n", ((XmAnyCallbackStruct *)call_data)->event->xbutton.button);
		}

	if (((XmAnyCallbackStruct *)call_data)->event->xbutton.button != Button1)
		return;


	if (strcmp(applResources.command,"") == 0)
		{
		if (applResources.tracelevel > 0)
			{
			fprintf(stderr,"no command to execute");
			}
		ringbell(0);
		return;
		}
	
	if (fork() != 0)
		{
		/*
		 * make the button insensitive,
		 * prepare a handler for the death of the child
		 * remove the timer
		 */
		XtSetSensitive(buttonW, False);
		XSync(display,False);

		signal (SIGCHLD, childSH);

		if (timer)
			XtRemoveTimeOut(timer);
		return;
		}
	else
		{
		/* child */
		execlp("/bin/sh","sh","-c",applResources.command,(char *)0);
		fprintf(stderr,"exec 'sh %s' failed: %d (%s)\n",
			applResources.command,
			errno, sys_errlist[errno]);
		ringbell(0);
		exit(0);
		}
}

/*
 *	prepare Bitmaps
 *
 *	If Bitmaps are named as files, we'll try to load them
 *	otherwise the compiled-in bitmaps are set up.
 *
 *	Parameters
 *		w:	window
 *		pm:	pointer to pixmap to load
 *		pmfile:	name of file to load from
 *		data:	pointer to default pixmap
 *		width:	width of default pixmap
 *		height:	height of default pixmap
 */

void	loadBitmap(w,pm,pmfile,data,width,height)
Widget	w;
Pixmap	*pm;
char	*pmfile;
char	*data;
unsigned int	width, height;
{
	Pixel   foreground, 
		background;
	Arg     arglist[5];
	int     n;
	Screen	*TheScreen	= XtScreen(w);

	n = 0;
	XtSetArg(arglist[n], XmNbackground, &background); n++;
	XtSetArg(arglist[n], XmNforeground, &foreground); n++;
	XtGetValues(w, arglist, n);


	if (strcmp(pmfile,"") != 0)
		{
		if (((*pm) = XmGetPixmap(TheScreen, pmfile, 
			foreground, background)) != XmUNSPECIFIED_PIXMAP)
			{
			return;
			}
		fprintf(stderr,"couldn't load %s, using default pixmap\n",
			pmfile);
		}
	(*pm) = XCreatePixmapFromBitmapData(display,
		DefaultRootWindow(display), 
		data, width, height, 
		foreground, background,
		DefaultDepthOfScreen(TheScreen));
}


/*
 * CHECKMAILBOX
 *
 */

void	checkmailboxCB(w, client_data, call_data)
Widget	w;
caddr_t	client_data;
caddr_t	call_data;
{
	int		cc;
	Cardinal	n;
	Arg		args[10];
	int		ring = 0;
	static int	old_box_size = 0;

	cc = check_mail(mail_p);

	if (applResources.tracelevel > 0)
	{
		fprintf(stderr,"\n--> checkmailboxCB()\n");
		fprintf(stderr,"check_mail returns %d\n",cc);
		fprintf(stderr,"old_box_size is %d\n",old_box_size);
		fprintf(stderr,"currentstate =%d\n",currentstate);
	}
	
	if (((cc >  0) && (cc <= old_box_size)) || 
	    ((cc == 0) && (currentstate == XIB_EMPTY)))
	{
		timer = XtAppAddTimeOut(kontext, (applResources.interval*1000), 
				checkmailboxCB, (caddr_t)NULL);
		if (applResources.tracelevel > 0)
		{
			fprintf(stderr,"no state change\n");
			fprintf(stderr,"new timeout added for %d seconds\n",
					applResources.interval);
		}
		old_box_size = cc;
		return;
	}

	n = 0;

	if (cc>0) currentstate = XIB_FULL;
	     else currentstate = XIB_EMPTY;

	if (applResources.showtext == False)
		XtSetArg (args[n], XmNlabelPixmap, buttonpixmap[currentstate]); 
	else
		XtSetArg (args[n], XmNlabelString, buttontext[currentstate]);
	n++;
	XtSetValues(buttonW, args, n);

	if (applResources.tracelevel > 0)
	{
		String	buf;

		XmStringGetLtoR(buttontext[currentstate], XmSTRING_DEFAULT_CHARSET, &buf);
		fprintf(stderr,"          cc=%d\n",cc);
		fprintf(stderr,"old_box_size=%d\n",old_box_size);
		fprintf(stderr,"currentstate=%d\n",currentstate);
		fprintf(stderr,"buttontext[currentstate]=%s\n",buf);
		XtFree(buf);
	}


	if (cc > old_box_size)
		ring = 1;

	timer = XtAppAddTimeOut(kontext, (applResources.interval*1000), 
			checkmailboxCB, (caddr_t)NULL);
	if (applResources.tracelevel > 0)
		fprintf(stderr,"new timeout added for %d seconds\n",
				applResources.interval);
	if (ring)
		ringbell(currentstate);
	old_box_size = cc;
}


/*
 * signal handler for dying child
 *
 * when the child has returned, we can  make the button sensitive again
 * and start another check on the mailbox...
 */

void childSH(sig)
int	sig;
{
	if (applResources.tracelevel > 0)
		{
		fprintf(stderr,"received signal: %d\n", sig);
		}

	/* ignore further dying children */
	signal(SIGCHLD, SIG_IGN);

	checkmailboxCB(applShell,(caddr_t)NULL, (caddr_t)NULL);
	XtSetSensitive(buttonW, True);
	}


/*
 * ringbell
 *
 * execute different bell signals
 */

void	ringbell(mode)
int	mode;
{
	if (applResources.tracelevel > 0)
		fprintf(stderr,"ringing bell mode=%d\n", mode);

	switch(mode) {
		case XIB_FULL:	/*
				 * The Postman always rings twice
				 */
				XBell(display,100);
				XSync(display,False);
				sleep(1);
				XBell(display,100);
				XSync(display,False);
				break;
		default:	XBell(display,100);
				XSync(display,False);
				break;
		}
}

/*
 * print out all unknown parameters
 */

void paramerror(argcerr,argverr)
int	argcerr;
char	*argverr[];
{
	int	nchar;
	String	warning;
	int	i;

	nchar = 0;
	for (i=0; i<argcerr;i++)
		nchar += strlen(argverr[i]) +1;
	warning = XtMalloc((nchar+30) * sizeof(char));

	strcpy(warning, "Wrong parameters:");
	for (i=0;i<argcerr;i++)
	{
		strcat(warning, " ");
		strcat(warning, argverr[i]);
	}

	XtAppWarning(kontext, warning);

	XtFree(warning);
}


/*
 * check the User's Mailbox
 */

int check_mail(mail_p)
char * mail_p;
{
	struct stat finf;
	int mail_new = 0;
	if (applResources.tracelevel > 0)
		fprintf (stderr, "Mailbox is %s\n", mail_p);

	if (stat(mail_p, &finf) == 0)
		mail_new = finf.st_size;
	return (mail_new);
}
